/******************************************************************************

襭 ⥬  ࠨ᪨ ࠢ ()
⮤ . 롮 饣   ⮫ v. 1.0

(c) 2002 ⠭᫠               <xstazz@hotbox.ru>

ணࠬ ࠡ             http://vt.spbgmtu.ru

******************************************************************************/


#include <math.h>
#include <conio.h>
#include "matrix6.cpp"


//襭  ⮤ 
TMatrix<double> linearSolveGaussColLead(TMatrix<double> &as,// .
					TMatrix<double> &bs)//ࠢ 
{
   TMatrix<double> a(as), b(bs);
   int n=a.getSizeRow();
   double eps = 0.000001;

   //אַ 室
   for(int k=1; k<=n; k++)
   {
      // ᨬ쭮     ⮫
      double max=0;
      int max_i=-1;

      for(int i=k; i<=n; i++)
      {
	 if(fabs(a(i,k))>max)
	 {
	    max=fabs(a(i,k));
	    max_i=i;
	 }
      }
      if(max_i==-1 || fabs(a(max_i,k))<eps)
      {
	 cout<<"訡: ।⥫ ࠢ "<<endl;
      }
      else
      {
	 if(max_i!=k)
	 {
	    // ப
	    a.swapRow(max_i,k);
	    b.swapRow(max_i,k);
	 }
      }

      //㫥 ⮢
      double lead=a(k,k);

      for(int j=k; j<=n; j++)
      {
	 a(k,j)/=lead;
      }
      b[k]/=lead;

      for(i=k+1; i<=n; i++)
      {
	 double a_div_lead=a(i,k)/a(k,k);

	 for(j=k; j<=n; j++)
	 {
	    a(i,j)-=a(k,j)*a_div_lead;
	 }
	 b[i]-=b[k]*a_div_lead;
      }
   }

   // 室
   TMatrix<double> x(n,1);
   x[n]=b[n];

   for(k=n-1; k>=1; k--)
   {
      double sum=b[k];

      for(int j=k+1; j<=n; j++)
      {
	 sum-=a(k,j)*x[j];
      }

      x[k]=sum;
   }

   return x;
}


void main(void)
{
   char ch;
   TMatrix<double> a_b;

   cout.setf(ios::showpoint);

   for(;;)
   {
      clrscr();
      cout<<"襭 ⥬  ࠨ᪨ ࠢ"<<endl
	 <<"⮤ . 롮 饣   ⮫"<<endl<<endl
	 <<"1   -    䠩"<<endl
	 <<"2   -  "<<endl
	 <<"Esc - 室"<<endl<<endl<<endl;

      do
      {
	 ch=getch();
      }
      while(ch!='1' && ch!='2' && ch!=27);

      switch(ch)
      {
	 case '1':
	 {
	    clrscr();
	    char str[20];
	    cout<<"  䠩:"<<endl;
	    cin>>str;
	    ifstream in_file(str);
	    if(in_file)
	    {
	       int n;
	       in_file>>n;
	       a_b.setSize(n,n+1);
	       a_b.readArray(in_file);
	       a_b.writeArray(cout);
	    }
	    else
	    {
	       cout<<"   䠩 \""<<str<<"\""<<endl;
	    }
	    getch();
	    break;
	 }
	 case '2':
	 {
	    TMatrix<double> x;
	    clrscr();
	    cout<<"襭 "<<endl;
	    cout<<"७  ⥬:"<<endl;
	    a_b.writeArray(cout);

	    int n=a_b.getSizeRow();
	    TMatrix<double> a(a_b.getPart(1,1,n,n)), b(a_b.getCol(n+1));
	    x=linearSolveGaussColLead(a,b);
	    cout<<"襭: "<<endl;
	    x.writeArray(cout);

	    ofstream out_file("result.txt");
	    if(out_file)
	    {
	       out_file<<"襭 "<<endl;
	       out_file<<"७  ⥬:"<<endl;
	       a_b.writeArray(out_file);
	       out_file<<"襭: "<<endl;
	       x.writeArray(out_file);
	    }
	    else
	    {
	       cout<<"  ᮧ 䠩 \"result.txt\""<<endl;
	    }

	    getch();
	    break;
	 }
	 case 27:
	 {
	    return;
	 }
      }
   }
}
